
;*****************************************************************************
;*                            DIMMER MIT POTI                                *
;*                                                                           *
;*                            19.02.24                                       *
;*                                                                           *
;*****************************************************************************

        LIST    P=12F675       
        TITLE   "DIMMER"

        ERRORLEVEL -302
        INCLUDE <P12F675.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_ON & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------
                                                                                      
; ALS PIC-IC WURDE GENOMMEN PIC12F675
    
; ALS OSZILLATOR WURDE DER INTERNE OSZILLATOR MIT 4,0MHZ GENOMMEN.  (T=0.250SEC ALSO DIE TAKTZEIT) (T=1:FREQUENZ) 
; EIN BEFEHL HAT MEIST 4 TAKTE SIND 1,0SEC       
;
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;HIER KANN MAN AENDERN:
;EIN SEMIKOLON DAVOR BEWIRKT DAS DER "BEFEHL" ALS KOMMENTAR GILT. 
;
FREQUENZ                EQU  D'2'   ;JETZT IST MIT CA. 60HZ FREQUENZ BEI D'2' EINGESTELLT.
                                    ;MAN SOLLTE DIE FREQUENZ NUR ERHHEN --> DANN D'1' // D'0' GEHT NICHT
                                    
GESCHWINDIGKEIT         EQU  D'10'  ;DIE IST DIE HOCH- UND RUNTER-FAHR-GESCHWINDIGKEIT // ALSO WIE LANGE ES BRAUCHT VON HELL BIS DUNKEL ...
                                    ;ES GEHEN NUR ZAHLEN VON D'10' BIS D'255'                
                                    ;JETZT MIT D'10' // HIER POTI EINSTELLBARE HOCH/RUNTER FAHR-DAUER VON 1 SEC BIS  40 SEC
                                    ;WENN ES LANGSAMER WERDEN SOLL GROESSER D'10' MACHEN // SCHNELLER GEHT NICHT !!!
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 21 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

HELP0                   EQU 0X21
HELP1                   EQU 0X22
AD_H                    EQU 0X23
AD_L                    EQU 0X24

MERK                    EQU 0X25               
ZAE                     EQU 0X26
ZAE1                    EQU 0X27
HELL_H                  EQU 0X28
HELL_L                  EQU 0X29
DUNKEL_H                EQU 0X2A
DUNKEL_L                EQU 0X2B
HELL0_H                 EQU 0X2C
HELL0_L                 EQU 0X2D
DUNKEL0_H               EQU 0X2E
DUNKEL0_L               EQU 0X2F
HOCHRUNTER              EQU 0X30
ZAEHLER_L               EQU 0X31
ZAEHLER_H               EQU 0X32

W_STACK                 EQU 0X33               ;FUER PUSH UND POP
S_STACK                 EQU 0X34               ;FUER PUSH UND POP

;------------------------- MACROS -----------------------------------------
BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------
;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; SPRUNG ZUM INTERRUPTPROGRAMM

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'00110100'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP0 + GP1 DIGITAL I/O     AN2 (GP2) -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11111100'                 ;GP0 + GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS (0X03FF) BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL

;INIT TIMER 0 FUER ZEITSCHLEIFE
                        MOVLW   B'10000011'                 ;BIT0-2 111=PRESCALER16, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0
;INIT TIMER 1 FUER ZEITSCHLEIFE
;                        MOVLW   B'00000000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [00]1:1 VORERST 0
;                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG
                        MOVLW   B'10001000' ;ADMF=1 RECHTSBNDIG, VDD ALS REF, CHANNEL AN2, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;---------------INITIALISIERUNG--ZU--ENDE-----------------------
                        
                BCF     GPIO, BIT0          ;LEUCHTET NICHT
                BCF     GPIO, BIT1          ;LEUCHTET NICHT
 
                MOVLW   D'100'
                CALL    ZS1MSEC             ;ZEITSCHLEIFE 100MSEC ZUM AUFLADEN VON 47NF KONDENSATOR AM SCHLEIFER VOM EINSTELLREGLER FR AD-MESSUNG USW.....

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ABFRAGE_HO      BSF     HOCHRUNTER, BIT0    ;MERKER BIT GESETZT FUER HOCHDIMMEN
                BCF     HOCHRUNTER, BIT1    ;MERKER BIT FUER ENDEERKENNUNG LOESCHEN
                CALL    AN_MESSEN
                GOTO    ANFANG


ABFRAGE_RU      BCF     HOCHRUNTER, BIT0    ;MERKER BIT GESETZT FUER RUNTERDIMMEN
                BCF     HOCHRUNTER, BIT1    ;MERKER BIT FUER ENDEERKENNUNG LOESCHEN
                CALL    AN_MESSEN
;               GOTO    ANFANG

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ANFANG      BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    ANFANG

                        MOVF    HELL0_L, W
                        MOVWF   HELL_L                 
                        MOVF    HELL0_H, W
                        MOVWF   HELL_H

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

                        BSF     GPIO, GP1       ;LED EIN
                        BCF     GPIO, GP0       ;LED AUS

WEITER1                 MOVLW   FREQUENZ
                        CALL    ZS3MUESEC
 
                        MOVLW   D'1'            
                        SUBWF   HELL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1
                        MOVLW   D'1'
                        SUBWF   HELL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1         

;------------------------------- 
SE1         BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    SE1
 
                        MOVF    DUNKEL0_L, W
                        MOVWF   DUNKEL_L                 
                        MOVF    DUNKEL0_H, W
                        MOVWF   DUNKEL_H   

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN
            
                        BCF     GPIO, GP1       ;LED AUS
                        BSF     GPIO, GP0       ;LED EIN

WEITER2                 MOVLW   FREQUENZ
                        CALL    ZS3MUESEC
 
                        MOVLW   D'1'            
                        SUBWF   DUNKEL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2
                        MOVLW   D'1'
                        SUBWF   DUNKEL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2         

                        BTFSS   HOCHRUNTER, BIT1    ;ENDEKENNUNG ABFRAGEN
                        GOTO    ANFANG

SEA                     BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
                        BTFSC   INTCON, GIE
                        GOTO    SEA
                        
                        BTFSS   HOCHRUNTER, BIT0
                        GOTO    EIN1

                        BSF     GPIO, GP1       ;LED IST KOMPLETT AUS
                        BCF     GPIO, GP0       ;LED IST KOMPLETT EIN
                        GOTO    WW1

EIN1                    BSF     GPIO, GP1       ;LED IST KOMPLETT EIN
                        BCF     GPIO, GP0       ;LED IST KOMPLETT AUS
            
WW1                     BTFSS   HOCHRUNTER, BIT0
                        GOTO    ABFRAGE_HO          ;ZU HOCHDIMMEN
                        GOTO    ABFRAGE_RU          ;ZU RUNTERDIMMEN
 

;*****************************************************************************
;*                              INTERRUPT                                    *
;*****************************************************************************
INTERRUPT       PUSH
                        
                DECFSZ  MERK, F             ;2 DECREMENTIEREN  --> INTERRUPT 2X DURCHLAUFEN DANN HELL UND DUNKEL NDERN +1 -1
                GOTO    AA1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                BTFSS   HOCHRUNTER, BIT0
                GOTO    INTR

                MOVLW   D'1'            
                SUBWF   DUNKEL0_L, F
                BTFSC   STATUS, C
                GOTO    INT1
                DECF    DUNKEL0_H, F

INT1            INCFSZ  HELL0_L, F
                GOTO    INT2
                INCF    HELL0_H, F

INT2            INCFSZ  ZAEHLER_L, F
                GOTO    INT3
                INCF    ZAEHLER_H, F
                GOTO    INT3



INTR            MOVLW   D'1'            
                SUBWF   HELL0_L, F
                BTFSC   STATUS, C
                GOTO    INT1R
                DECF    HELL0_H, F

INT1R           INCFSZ  DUNKEL0_L, F
                GOTO    INT2R
                INCF    DUNKEL0_H, F

INT2R           INCFSZ  ZAEHLER_L, F
                GOTO    INT3
                INCF    ZAEHLER_H, F



INT3            MOVLW   GESCHWINDIGKEIT
                MOVWF   MERK
                                       ;SCHWIERGIKEIT HIER EIGENTLICH 0X03FE !!!!!!!!!!!!!!!!!!!!!!!!!!!!
                MOVLW   0XE0           ;ENDE BEI 0X03E0 -- ZAEHLER                   
                SUBWF   ZAEHLER_L, W
                BTFSS   STATUS, C
                GOTO    AA1

                MOVLW   0X03                   
                SUBWF   ZAEHLER_H, W
                BTFSS   STATUS, Z
                GOTO    AA1
                
                BSF     HOCHRUNTER, BIT1 ;ENDEKENNUNG

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AA1             MOVF    AD_L, W         ;ZEIT FUER TIMER0        
                MOVWF   TMR0                    
                BCF     INTCON, T0IF          ;OVERFLOW = 0
                
                POP
                RETFIE
                
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;---------------------- UNTERPROGRAMME -----------------------------------------
            
;*****************************************************************************
;*                              AD-MESSUNG                                   *
;*****************************************************************************
AN_MESSEN               BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                        BSF     ADCON0, ADON   ;SCHON OBEN BEI INITIALISIERUNG
                        MOVLW   D'14'               ;14*3SEC=42SEC
                        CALL    ZS3MUESEC           ;ZEITSCHLEIFE
                        BSF     ADCON0, GO_DONE     ;GEHT LOS

III                     BTFSS  PIR1, ADIF
                        GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN       
                        BCF     ADCON0, GO_DONE
                        
;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;BERECHNUNG
                        BCF     STATUS, C
                        RRF     AD_H, F     ;2MAL NACH RECHTS SCHIEBEN
                        RRF     AD_L, F     ;ZU 0XFF MACHEN, AD_H ENTFLLT DANN
                        
                        BCF     STATUS, C
                        RRF     AD_H, F
                        RRF     AD_L, F
                        
;SUBTRAKTION / DURCHLUFE BERECHNEN
                        MOVF    AD_L, W     ;AD_L DARF NICHT NULL WERDEN SONDERN 0X01
                        SUBLW   0X00        
                        BTFSC   STATUS, Z
                        INCF    AD_L, F     

                        MOVF    AD_L, W     ;AD_L DARF NICHT 0XFF WERDEN SONDERN 0XFE
                        SUBLW   0XFF
                        BTFSC   STATUS, Z
                        DECF    AD_L, F
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                MOVLW   GESCHWINDIGKEIT
                MOVWF   MERK

                MOVLW   0X01            ;ENDEERKENNUNGS-ZAEHLER LADEN
                MOVWF   ZAEHLER_L
                CLRF    ZAEHLER_H

;ENTSCHEIDEN OB HOCH- ODER RUNTER-DIMMEN
                BTFSS   HOCHRUNTER, BIT0
                GOTO    RUNT

;RAM-ZELLEN LADEN FUER DAS HOCH-DIMMEN
                MOVLW   0X01
                MOVWF   HELL0_L
                CLRF    HELL0_H
   
                MOVLW   0XFF
                MOVWF   DUNKEL0_L
                MOVLW   0X03
                MOVWF   DUNKEL0_H
                GOTO    INTZULAS

;RAM-ZELLEN LADEN FUER DAS RUNTER-DIMMEN
 RUNT           MOVLW   0X01
                MOVWF   DUNKEL0_L
                CLRF    DUNKEL0_H
   
                MOVLW   0XFF
                MOVWF   HELL0_L
                MOVLW   0X03
                MOVWF   HELL0_H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;INTERRUPT ZULASSEN
INTZULAS        BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE
                BSF     INTCON, PEIE
                BSF     INTCON, T0IE    ;ENABLE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                MOVF    AD_L, W         ;ZEIT FUER TIMER1        
                MOVWF   TMR0                    
                BCF     INTCON, T0IF    ;OVERFLOW = 0

                RETURN

;*****************************************************************************
;*                            ZEITSCHLEIFE  CA. X-MAL 3SEC                  *
;*****************************************************************************
ZS3MUESEC               MOVWF   HELP0
ZZS                     ;NOP         ;EIN NOP = 0.250SEC *(T=4) = 1,0SEC  
           
                        DECFSZ  HELP0, F
                        GOTO    ZZS 
                        RETURN    
;DER OSZILLATOR MIT 4,0MHZ --> (T=0.250SEC ALSO DIE TAKTZEIT)
;WEGEN DECFSZ (T=4) UND GOTO (T=8) -->GESAMT T=12 * 0,250SEC=3,0SEC
           
;*****************************************************************************
;*                            ZEITSCHLEIFE TIMER0 X-MAL 1MSEC                *
;*****************************************************************************                   
ZS1MSEC                 MOVWF   HELP1

Z01                     MOVLW   D'194'
                        MOVWF   TMR0                    
                        BCF     INTCON, T0IF          ;OVERFLOW = 0
                 
Z02                     BTFSS   INTCON, T0IF            
                        GOTO    Z02                    
                      
                        DECFSZ  HELP1, F
                        GOTO    Z01
                        
                        RETURN

;ZEITBERECHNUNG FUER 1MSEC
;PRESCALER 16X  +  SYSTEM 4X  ====> 16*4*0.25SEC=16SEC
;1MSEC:16,0SEC=62,5    
;TMR0 ALSO D'256'-D'62'=D'194' ENTSPRICHT CA. 1MSEC
;194 DEZIMAL OBEN EINTRAGEN
                
                        
                        END